#!/bin/bash
#PBS -l nodes=4096:ppn=24
#PBS -l walltime=00:10:00
#PBS -N PRACE4477_Wombat_4096
#PBS -m abef

cd  /lustre/cray/ws8/ws/iprjudon-WENOWombat/WENOWombat/weak 

export MPICH_MAX_THREAD_SAFETY=multiple # enable THREAD_MULTIPLE
export MPICH_VERSION_DISPLAY=1            # show library version

export NNODES=4096

export RANKS_PER_NODE=4
export OMP_NUM_THREADS=6

export MPI_NUM_RANKS=$[ $RANKS_PER_NODE * $NNODES ]

echo "Number of Nodes       : " $NNODES
echo "Number of MPI Ranks   : " $MPI_NUM_RANKS
echo "Number of OMP Threads : " $OMP_NUM_THREADS

echo "Number of Cores       : " $[ $MPI_NUM_RANKS * $OMP_NUM_THREADS ]

aprun -N $RANKS_PER_NODE -n $MPI_NUM_RANKS -d $OMP_NUM_THREADS  ../wombat/wombat_weno_suite par/blob_4096.par &> log/blob_4096.log

exit
