! Always need the compile time macros.
#include "../macro.h"

! In case this is a compile time switchable module. else leave it out.
#ifdef MYMODULE

MODULE MOD_Mymodule  ! Name of your module = filename

! We like to have a header, if files get send around on their own ...

! FILENAME: mymodule.f90
!
! DESCRIPTION: Say what you do not how you do it ! Mention papers you used.
!
! DEPENDENCIES:  What other files depend on this one ?
!
! HISTORY:
!     1/1/2017 - Wombat Programmer      ! first touch only. 

! require other modules ? These ones are usually good to have ...

USE Mod_Globals
USE Mod_Error
USE Mod_Parameters
USE Mod_SimulationUnits
USE Mod_Patch

IMPLICIT NONE ! This is Fortran after all

PRIVATE ! All objects of this class are private by default (encapsulation)

PUBLIC :: MyType ! That's the object that can be seen from the outside.

TYPE MyType ! Declare the public object MYTYPE. You can have many of those

      PRIVATE ! default is to hide all object variables

      INTEGER(WID) :: height, width  ! private object variables
      REAL(WRD), PUBLIC :: volume    ! a public object variable

      CONTAINS ! now come the methods

      PRIVATE  ! hide them by default

      PROCEDURE, PUBLIC :: destroy ! Always need a public destructor to call from wombat.f90

      PROCEDURE :: DoSomething     ! this one is hidden.

END TYPE MyType

! now write an interface to the constructor, so the object MyType can
! be instantiated with 
!                    object = MyType(parameters)
INTERFACE MyType

    MODULE PROCEDURE constructor

END INTERFACE MyType

! The constructor takes a bunch of parameters and returns a new MyType
! object called "self". Please stick to this format.
FUNCTION constructor(param, rankloc, simunits) RESULT(self)
   
    TYPE(MyType) :: self ! call the new object "self" already here

    TYPE(Parameters) :: param
    TYPE(RankLocation) :: rankloc
    TYPE(SimulationUnits) :: simunits
    
    ! Read a bunch of parameters from the parameter file

    CALL param%section("MyType section")
    
    self%height = param%getInt("height", "173", "# Height in cm")
    self%width = param%getInt("width", "10", "# width in cm", 0, .TRUE.) ! advanced parameter column 0

    ! for more complicated parameter sets with multi-columns see io_dump.f90

    self%volume = self%height * self%width

    CALL param%comment("some description")

    RETURN 

END FUNCTION constructor
      
CONTAINS ! Now come the object methods

! The public destroy method
SUBROUTINE destroy(self)

    CLASS(Problem) :: self
    
    !do nothing
    
END SUBROUTINE destroy

! A private method
SUBROUTINE DoSomething(self, nSomething)
    
    CLASS(Problem) :: self

    INTEGER(WID), INTENT(IN) :: nSomething

    REAL(WRD) :: x

    ! do something

END SUBROUTINE DoSomething

END MODULE

#endif


